// layout style

@use 'fun';

// slice or clone
@mixin box-decoration($value) {
  box-decoration-break: $value;
}

// border-box or content-box
@mixin box-sizing($value) {
  box-sizing: $value;
}

// block inline-block inline flex inline-flex table inline-table table-caption
// table-cell table-column table-column-group table-footer-group table-header-group
// table-row-group table-row flow-root grid inline-grid contents list-item none
@mixin display($value) {
  display: $value;
}

// left right none
@mixin float($value) {
  float: $value;
}

// left right both none
@mixin clear($value) {
  clear: $value;
}

// contain cover fill none scale-down
@mixin object-fit($value) {
  object-fit: $value;
}

// keyword: top bottom left right center
// keyword [keyword]
// percentage or length with two values
@mixin object-position($value) {
  object-position: $value;
}

// auto hidden clip visible scroll
@mixin overflow($value) {
  overflow: $value;
}

// x or y
// when direction is anchor, value is auto or none
// when direction is block, value is visible hidden scroll auto
// when direction is inline, value is visible hidden scroll or auto
// when direction is wrap, value is normal break-word or anywhere
@mixin overflow-with($direction, $value) {
  @include fun.affix('overflow', $value, #{$direction});
}

// static fixed absolute relative sticky
@mixin position($value) {
  position: $value;
}

@mixin top($value: auto) {
  top: $value;
}

@mixin bottom($value: auto) {
  bottom: $value;
}

@mixin left($value: auto) {
  left: $value;
}

@mixin right($value: auto) {
  right: $value;
}

@mixin inset($value: auto) {
  inset: $value;
}

@mixin inset-block($value: auto) {
  inset-block: $value;
}

@mixin inset-block-end($value: auto) {
  inset-block-end: $value;
}

@mixin inset-block-start($value: auto) {
  inset-block-start: $value;
}

@mixin inset-inline($value: auto) {
  inset-inline: $value;
}

@mixin inset-inline-end($value: auto) {
  inset-inline-end: $value;
}

@mixin inset-inline-start($value: auto) {
  inset-inline-start: $value;
}

// visible hidden collapse
@mixin visibility($value) {
  visibility: $value;
}

// auto or number(>=0)
@mixin z-index($value) {
  z-index: $value;
}

// auto number or size
@mixin columns($value) {
  columns: $value;
}

// auto avoid all avoid-page page left right column
@mixin break-after($value) {
  break-after: $value;
}

// auto avoid all avoid-page page left right column
@mixin break-before($value) {
  break-before: $value;
}

// auto avoid all avoid-page avoid-column
@mixin break-inside($value) {
  break-inside: $value;
}
